Attribute VB_Name = "File"
'/*
'WordBastard - rich text editor
'File.bas - file routines
'Copyright  (C) 1998-2000 Hugues Johnson
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
'the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'*/

Public Sub OpenFile(rtf As Control, dlg As Control)
    Dim FileName As String
    
    On Error GoTo errOpenFile
    
    If ((TypeOf rtf Is RichTextBox) And (TypeOf dlg Is CommonDialog)) Then
        rtf.SelBullet = False
        dlg.Filter = FILTER_FILE
        dlg.ShowOpen
        FileName = dlg.FileName
        Select Case LCase$(Right$(FileName, 3))
            Case vbNullString:
                Exit Sub
            Case "uue":
                rtf.LoadFile FileName
                OpenUUE rtf
            Case Else:
                rtf.LoadFile FileName
        End Select
    End If
    
exitSub:
    Exit Sub

errOpenFile:
    If (Err.Number = cdlCancel) Then
        Err.Clear
    Else
        ErrorHandler Err, "OpenFile"
    End If
    Resume exitSub
    
End Sub

Public Sub SaveFileAs(rtf As Control, dlg As Control)
    Dim NewFile As String
    
    On Error GoTo errSaveFileAs
    
    If ((TypeOf rtf Is RichTextBox) And (TypeOf dlg Is CommonDialog)) Then
        dlg.Filter = FILTER_FILE
        dlg.ShowSave
        NewFile = dlg.FileName
        If (Len(Trim$(sNewFile)) > 0) Then
            Select Case LCase$(Right$(NewFile, 3))
                Case "rtf":
                    rtf.SaveFile NewFile, rtfRTF
                Case "uue":
                    rtf.SaveFile NewFile, rtfText
                    ConvertToUUE (NewFile)
                Case Else:
                    rtf.SaveFile NewFile, rtfText
            End Select
            rtf.FileName = NewFile
        End If
    End If
    
exitSub:
    Exit Sub

errSaveFileAs:
    If (Err.Number = cdlCancel) Then
        Err.Clear
    Else
        ErrorHandler Err, "SaveFileAs"
    End If
    Resume exitSub

End Sub

Public Sub SaveFile(rtf As Control)
      
    On Error GoTo errSaveFile
    
    If (TypeOf rtf Is RichTextBox) Then
        Select Case LCase$(Right(rtf.FileName, 3))
            Case vbNullString: MsgBox "Please use 'Save As'.", vbOKOnly, "No file exists"
            Case "rtf":
                rtf.SaveFile rtf.FileName, rtfRTF
            Case "uue":
                rtf.SaveFile rtf.FileName, rtfText
                ConvertToUUE (rtf.FileName)
            Case Else:
                rtf.SaveFile rtf.FileName, rtfText
        End Select
    End If
    
exitSub:
    Exit Sub

errSaveFile:
    If (Err.Number = cdlCancel) Then
        Err.Clear
    Else
        ErrorHandler Err, "SaveFile"
    End If
    Resume exitSub

End Sub



Public Sub PrintDocument(rtf As Control, dlg As Control)

    'This doesn't work all too well - it's also rather low on my list of priorities
    
    On Error GoTo errPrintDocument

    dlg.Flags = cdlPDReturnDC + cdlPDNoPageNums
    If (rtf.SelLength = 0) Then
        dlg.Flags = dlg.Flags + cdlPDAllPages
    Else
        dlg.Flags = dlg.Flags + cdlPDSelection
    End If
    dlg.ShowPrinter
    Printer.Print ""
    rtf.SelPrint dlg.hDC

exitSub:
    Exit Sub

errPrintDocument:
    If (Err.Number = cdlCancel) Then
        Err.Clear
    Else
        ErrorHandler Err, "PrintDocument"
    End If
    Resume exitSub
    
End Sub

Public Sub PrintPreview()

    'Nope, nothing here yet....


End Sub



Public Sub ConvertToUUE(FileName As String)

    'Honest - I wrote this routine for another project but haven't ported it over yet

End Sub

Public Sub OpenUUE(rtf As Control)

    'Honest - I wrote this routine for another project but haven't ported it over yet

    If (TypeOf rtf Is RichTextBox) Then
    
    End If

End Sub
