Attribute VB_Name = "INI_Routines"
'/*
'WordBastard - rich text editor
'INI_Routines.bas - .ini file routines
'Copyright  (C) 1998-2000 Hugues Johnson
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
'the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'*/

Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Sub SaveSetting(Section As String, Key As String, Value As String)

    WritePrivateProfileString Section, Key, Value, App.Path & "\WordBastard.ini"

End Sub

Public Function GetSetting(Section As String, Key As String) As String
    Dim temp As String * 50

    On Error GoTo errGetSetting

    GetPrivateProfileString Trim$(Section), Trim$(Key), "", temp, Len(temp), App.Path & "\WordBastard.ini"

exitFunction:
    GetSetting = Trim$(temp)
    Exit Function

errGetSetting:
    ErrorHandler Err, "GetSetting", "Section=" & Section & vbNewLine & "Key=" & Key
    Resume exitFunction

End Function

Public Sub CreateInitialFile()

    On Error GoTo errCreateInitialFile
    
    'Visual Settings
    WritePrivateProfileString "Layout", "Left", "0", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "Layout", "Top", "0", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "Layout", "Height", "200", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "Layout", "Width", "400", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "Layout", "WindowState", "0", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "Layout", "Toolbar", "1", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "Layout", "FormatBar", "1", App.Path & "\WordBastard.ini"
    
    'RichTextBox Settings
    WritePrivateProfileString "RTF", "SelFontName", "Times New Roman", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "RTF", "SelFontSize", "10", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "RTF", "SelColor", "0", App.Path & "\WordBastard.ini"
    WritePrivateProfileString "RTF", "BackColor", "1677215", App.Path & "\WordBastard.ini"
    
exitSub:
    Exit Sub
    
errCreateInitialFile:
    ErrorHandler Err, "CreateInitialFile"
    Resume exitSub

End Sub


Public Function PlaylistCount() As Long
    Dim temp As String * 50

    GetPrivateProfileString "General", "ListCount", "", temp, Len(temp), App.Path & "\PlayList.ini"

     PlaylistCount = CLng(temp)

End Function

Public Sub LoadPlayListNames(cb As Control)
    Dim q As Integer
    Dim ListName As String
    Dim temp As String * 64

    If (TypeOf cb Is ComboBox) Then
        If (PlaylistCount >= 1) Then
            For q = 1 To PlaylistCount
                ListName = "List" & Trim$(Str$(q))
                GetPrivateProfileString ListName, "ListName", "", temp, Len(temp), App.Path & "\PlayList.ini"
                cb.AddItem Trim$(temp)
             Next q
        End If
    End If

End Sub
