Attribute VB_Name = "Process_List_NT"
'/*
'WordBastard - rich text editor
'Process_list_NT.bas - process list for NT (and 2000)
'Copyright  (C) 1998-2000 Hugues Johnson
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
'the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
'*/

Option Explicit

'See also KB article Q175030

'===========================================================
'WINDOWS NT ONLY
'-----------------------------------------------------------
'PSAPI.DLL does not operate on Windows 95/98, use the
'ToolHelp32 APIs instead.
'Remember to distribute the PSAPI.DLL file (available in the
'Platform SDK. with any executable that uses it, as it is
'not currently distributed with the operating system.
'===========================================================

Public Declare Function CloseHandle Lib "Kernel32.dll" (ByVal Handle As Long) As Long
Public Declare Function OpenProcess Lib "Kernel32.dll" (ByVal dwDesiredAccessas As Long, ByVal bInheritHandle As Long, ByVal dwProcId As Long) As Long
Public Declare Function EnumProcesses Lib "psapi.dll" (ByRef lpidProcess As Long, ByVal cb As Long, ByRef cbNeeded As Long) As Long
Public Declare Function GetModuleFileNameExA Lib "psapi.dll" (ByVal hProcess As Long, ByVal hModule As Long, ByVal moduleName As String, ByVal nSize As Long) As Long
Public Declare Function EnumProcessModules Lib "psapi.dll" (ByVal hProcess As Long, ByRef lphModule As Long, ByVal cb As Long, ByRef cbNeeded As Long) As Long

Public Const PROCESS_QUERY_INFORMATION = 1024
Public Const PROCESS_VM_READ = 16
Public Const MAX_PATH = 260
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const SYNCHRONIZE = &H100000
Public Const PROCESS_ALL_ACCESS = &H1F0FFF


Public Function FillProcessListNT(tree As TreeView) As Long
    Dim cb As Long
    Dim cbNeeded As Long
    Dim NumElements As Long
    Dim ProcessIDs() As Long
    Dim cbNeeded2 As Long
    Dim NumElements2 As Long
    Dim Modules(1 To 200) As Long
    Dim lRet As Long
    Dim moduleName As String
    Dim nSize As Long
    Dim hProcess As Long
    Dim i As Long
    Dim ProcessName As String
    Dim ChildProcessName As String
    Dim ModDllCount As Long
    Dim ProcessCount As Integer
    Dim nd As Node

    tree.Nodes.Clear
    
    cb = 8
    cbNeeded = 96
    
    Do While (cb <= cbNeeded)
        cb = cb * 2
        ReDim ProcessIDs(cb / 4) As Long
        lRet = EnumProcesses(ProcessIDs(1), cb, cbNeeded)
    Loop
    
    NumElements = cbNeeded / 4
    
    For i = 1 To NumElements
        hProcess = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, ProcessIDs(i))
        If (hProcess) Then
            lRet = EnumProcessModules(hProcess, Modules(1), 200, cbNeeded2)
            If (lRet <> 0) Then
                moduleName = Space(MAX_PATH)
                nSize = 500
                lRet = GetModuleFileNameExA(hProcess, Modules(1), moduleName, nSize)
                ProcessName = Left$(moduleName, lRet)
                Set nd = tree.Nodes.Add(, , ProcessName, ProcessName)
                ProcessCount = ProcessCount + 1
                ModDllCount = 1
                Do
                    ModDllCount = ModDllCount + 1
                    moduleName = Space(MAX_PATH)
                    nSize = 500
                    lRet = GetModuleFileNameExA(hProcess, Modules(ModDllCount), moduleName, nSize)
                    ChildProcessName = Left$(moduleName, lRet)
                    If ChildProcessName = ProcessName Then Exit Do
                    If Trim$(ChildProcessName) <> "" Then
                        Set nd = tree.Nodes.Add(ProcessName, tvwChild, , ChildProcessName)
                    End If
                Loop
            End If
        Else
            FillProcessListNT = 0
        End If
        lRet = CloseHandle(hProcess)
    Next i
    
    FillProcessListNT = ProcessCount

End Function



